 ; local  a,b,c,d,e,f,g,h,w,x,y,z,x2,y2,x3,y3

Global mx,my,column,row,rx,ry,spx,spy, event, font1, font2     
Global loop,wait,hits,starsfound,score,miss,frameTimer,sound1,sound2
Global sprite1
Global star
Dim brd(10,10)
Dim brd2(10,10) 
Dim rt(10,10)   ; right
Dim lf(10,10)   ; left
Dim tp(10,10)   ; top
Dim bt(10,10)   ; bottom

Function start()
  ; qwerty
End Function

event = 1 
Graphics 900,700,16,2

Setup1()
Setup2()

SetBuffer BackBuffer()
ClsColor 0,0,10
Cls                                 
 


;@@@@@@@@@@@@@@@@@@@@@@@@@@@ start main loop @@@@@@@@@@@@@@@@@@@@@@@@@@
While loop=1
  
    Delay 50
    Cls
    If event = 1 Then Menu()
    WaitTimer (frameTimer)      ;delay using timer
    If event = 2 Then 
      InputLogic()
      PrintText()
      Logic1()
      UpdateBoard()
      DrawBoard()
    End If 
    VWait                   
    Flip
Wend 
 
FreeImage sprite1
FreeImage star
FreeTimer(frameTimer)
FreeFont font1 
FreeFont font2 
FreeSound sound1
FreeSound sound2

End

Function Menu()
    Local menu = 0

    Text 300,100, " THIS IS THE GAME OF TREASURE HUNT "
    Text 100,150, "   Click on any square to uncover it. You lose points for misses and "
    Text 100,180, " gain points for hits. Each square contains clues to where the treasure "
    Text 100,210, " pieces are located. There are 30 pieces to find. "
    Text 100,250, "   Click mouse to start. "
    Text 100,300, "   http://rb23.yolasite.com "

    VWait                   
    Flip

    While menu < 1
      Delay 100 
      If MouseDown (1) Then menu = 1
    Wend   
    event = 2
    SetFont font2 
 
    Delay 100

End Function 


Function InputLogic()

    Local a
            
    a=MouseDown (1)
    If a=0 And wait>1 Then wait=0

    If MouseDown(1) And wait=0 Then  
      wait=wait+1
      hits=hits+1
    EndIf

    mx = MouseX()                 ; get mouse position
    my = MouseY()
    rx = mx-190                   ; get x position relative to board
    If rx<1 Then rx=1
    column = rx/54+1                  ; get board column position
    If mx < 190 Then column = 0 
    If mx > 733 Then column = 0
    ry=my-30                    ; get y position relative to board
    If ry<1 Then ry=1
    row = ry/54+1
    If my < 30 Then row = 0                  ; get board row position
    If my > 570 Then row = 0 
      value=GetKey()
      If value = 32 Then 
        loop=0                      ; break out of loop
      End If 

End Function 

Function Setup1()
  Local a,b,c
  loop=1
  SeedRnd MilliSecs() 
  frameTimer=CreateTimer(60)

  font1 = LoadFont("Arial",24,0,0,0)
  font2 = LoadFont("System",16,0,0,0)
  SetFont font1 

  a=0
  While a<30
    
     b=Rand(1,10)
     c=Rand(1,10)
     If brd(b,c)=0 Then a=a+1
     brd (b,c)=1

  Wend  


End Function


Function Setup2()

sound1 = LoadSound("Data\boink4.wav")
sound2 = LoadSound("Data\boink2.wav")

;$$$$$$$$$$$$$$$$$$$$  sprite section $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
sprite1=CreateImage(54,54)          ; create empty sprite 
SetBuffer ImageBuffer(sprite1)       ; draw on sprite
Color 0,20,50                       ;dark blue square
Rect 0,0,54,54,1

star=CreateImage(48,48)          ; create empty sprite 
SetBuffer ImageBuffer(star)       ; draw star on sprite
Color 255,50,50                    ; light red                       
Rect 23,23,9,9,1                ; center=27
Color 180,180,255                
Line 27,16,27,39
Line 17,26,39,27
Line 12,12,42,42
Line 42,12,12,42

End Function





Function Logic1()
 Local a=0,b=0,c=0,d=0,e=0
 If wait=1  Then        
   brd2(column,row)=1
   wait=wait+1
   If wait>20 wait=20
   If brd(column,row) = 1 Then score=score+1
   If brd(column,row) = 0 Then miss=miss+1
   If brd(column,row) = 1 Then PlaySound sound2
   If brd(column,row) = 0 Then PlaySound sound1


   For a= 1 To 9
      If column + a < 11 And  brd(column + a,row) = 1 Then b = b + 1 ; right
      If column - a > 0  And  brd(column - a,row) = 1 Then c = c + 1 ; left
      If row + a < 11 And  brd(column,row + a) = 1 Then d = d + 1 ; down
      If row - a > 0  And  brd(column,row - a) = 1 Then e = e + 1 ; up
    rt(column,row)=b
    lf(column,row)=c
    bt(column,row)=d
    tp(column,row)=e

   Next  

 EndIf


End Function 



Function PrintText()
 ;If wait=1 Then
 
Color 255,255,255
;Cls                      ;clear back buffer

;If wait=1 Then
Text 10,100,"Hit space bar to end "
Text 10,115,"program"


Text 50,385,"SCORE"
Text 50,400,"mx="         ; print variable names
Text 50,415,"my="
Text 50,430,"column="
Text 50,445,"row="
Text 50,460,"rx="
Text 50,475,"ry="
Text 50,490,"hits"


Text 120,385,(score-miss)*10
Text 120,400, mx          ; print values
Text 120,415, my
Text 120,430, column
Text 120,445, row
Text 120,460, rx
Text 120,475, ry
Text 120,490, hits
Text 120,515, score



End Function 

;Function test()
;   DrawImage sprite1 ,100,200
;End Function 

 
Function UpdateBoard()
  Color 0,200,50

 x=190                      ; x,y starting points
 y=30

 For b=1 To 10              ; Draw 100 squares or objects

        spx=190+a*54
        For a= 1 To 10
        spy=30+b*54
         
 	   ; DrawBlock sprite1,x,y
        DrawImage sprite1,x,y        ; Draw the image (sprite)
           If brd(a,b)=1 And brd2(a,b)=1 Then 
             DrawImage star,x,y
           EndIf   
           If brd2(a,b)=1 Then
            Text x+42,y+21,rt(a,b)
            Text x+6,y+21,lf(a,b)
            Text x+23,y+38,bt(a,b)
            Text x+23,y+3,tp(a,b)
           EndIf 

        x=x+54              ; increase x row 48, each loop   
        Next 
 x=190                      ; x starting point
 y=y+54                     ; increase y row 48, each loop
 Next


End Function 

Function DrawBoard()

x=189                                ; start points
 y=29
 y2=31
									  ;draw frame
 Color 250,100,100                                      
 Line 188,27,732,27                   ;top
 Line 188,573,732,573                 ;bottom
 Line 187,28,187,572                  ;left
 Line 733,28,733,572                  ;right

 Color 50,200,255                     ; blue green
 For a=1 To 11
   Line x,y,731,y                     ; draw 11 horizontal lines
   Line x,y2,731,y2                   ; draw 11 horizontal lines
   y=y+54                             ; endpoint = 660 = 180+10*48
   y2=y2+54

 Next 

 Color 50,255,255
 x=189                                ; start points
 y=29
 x2=191

 For a=1 To 11
   Line x,y,x,570                     ; draw 11 vertical lines
   Line x2,y,x2,570                   ; draw 11 vertical lines
   x=x+54
   x2=x2+54                           ; endpoint = 529
                   
 Next 


End Function






  